.\"
.\" Copyright (c) 1996 Julian Elischer
.\"
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/at_shutdown.9,v 1.4.2.2 1999/09/05 11:27:13 peter Exp $
.\" "
.Dd August 15, 1996
.Os
.Dt AT_SHUTDOWN 9
.Sh NAME
.Nm at_shutdown ,
.Nm rm_at_shutdown
.Nd ask that a function be run at shutdown.
.Sh SYNOPSIS
.Fd #include <sys/param.h>
.Fd #include <sys/systm.h>
.Fd #include <sys/reboot.h>
.Ft typedef void \*(lp*bootlist_fn\*(rp\*(lpint howto, void *arg\*(rp

.Ft int
.Fn at_shutdown "bootlist_fn func" "void *arg" "int when"
.Ft int
.Fn rm_at_shutdown "bootlist_fn func" "void *arg"
.Sh DESCRIPTION
The
.Nm at_shutdown
facility allows a kernel module to ensure that it is notified
at system shutdown.
The function
.Fa func
is called with the flags indicating boot type, and the opaque argument
.Fa arg
when the system is shut down.
.Pp
If the requirement for notification is removed, then the function 
.Fn rm_at_shutdown
must be called with the exact
.Fa func
and
.Fa arg
arguments as the corresponding call to
.Fn at_shutdown .
There are two shutdown queues, one run before the final sync and one after.
The last argument to 
.Fa at_shutdown
should be one of 
.Dv SHUTDOWN_PRE_SYNC
or
.Dv SHUTDOWN_POST_SYNC
to specify which queue should be used.
.Fn rm_at_shutdown
will remove an entry from either queue.
.Pp
.Sh RETURN VALUES
.Fn at_shutdown
returns an error code, 0 meaning success. 
.Fn rm_at_shutdown
returns the number of items removed (should be 0 or 1).
.Sh SEE ALSO
.Xr reboot 2 ,
.Xr boot 9
.Sh HISTORY
The
.Fn at_shutdown
and
.Fn rm_shutdown
functions
appeared in
.Fx 2.2 .
.Sh BUGS
Since the shutdown queue is not sorted
and items are added to the head, order of execution 
is reversed to that of insertion.
.Sh AUTHORS
The function was written by
.ie t Julian Elischer (julian@freebsd.org)
.el Julian Elischer  (julian@freebsd.org)
